/* update eCS installation disks                                      */

/* get command line parameters */
parse arg cddir fpdir n.errors n.warnings n.elapsed log ver expert add_dani add_dummy f1dir f2dir
if datatype(f1dir) = 'NUM' then do
	vers = f1dir
	f1dir = ''
end

if iddir = '' | fpdir = '' then do
	say
	say ' Update eCS installation diskettes with fixpak.'
	say ' '
	say ' You are not supposed to manually run this program. Run go4it5.cmd'
	say ' or use the Graphical Interface (pmupdcd.exe)!'
	exit 1
end

/* we need to know the absolute path */
cdir  = chdir()
fpdir = strip(chdir(fpdir), 'T', '\')
cdir  = chdir(cdir) 
cddir = strip(chdir(cddir), 'T', '\') 
cdir  = chdir(cdir)
iddir = cddir||'\DISKIMGS'
exdir = cddir||'\DISKIMGS'

/* reset some variables */
if log = '' then log = 'updif.log'
if ver = '' then ver = '1.8'
if n.errors = '' then n.errors = 0
if n.warnings = '' then n.warnings = 0
if n.elapsed = '' then n.elapsed = 0
if expert  = '' then expert = 1

/* load configuration file */
call read_config_file 'updcd.cfg'

/* reset screen */
say '1B'x || '[36;44m'
say '1B'x || '[1m'
'@cls'
call rxfuncadd syscurstate, rexxutil, syscurstate
call syscurstate off
call rxfuncadd sysfiletree, rexxutil, sysfiletree
say '1B'x || '[2;2HUpdate eCS installation CD-ROM, version 'ver
say '1B'x || '[4;2HTarget directory      : 'substr(flpdrv'\', 1, 50)
say '1B'x || '[5;2HSource directory      : 'substr(iddir, 1, 50)
say '1B'x || '[7;2HCurrent activity      : 'substr('Thinking...', 1, 50)
say '1B'x || '[8;2HTarget object         : 'substr('Searching...', 1, 50)
say '1B'x || '[9;2HSource object         : 'substr('Searching...', 1, 50)
say '1B'x || '[11;2HUpdate action         : 'substr('Searching...', 1, 50)
say '1B'x || '[12;2HUpdate return code    : 0'
say '1B'x || '[14;2HElapsed time [m]      : 'trunc(time('E')/60 + n.elapsed, 2)
say '1B'x || '[15;2HNumber of errors      : 'n.errors
say '1B'x || '[16;2HNumber of warnings    : 'n.warnings
say '1B'x || '[17;2HUpdate log            : 'log
say '1B'x || '[19;2H'

/* insert 1.44MB floppy */
rcode = 1
do while rcode <> 0
	/* ask the user to do something useful :-) */
	if expert = 0 then do
		say '1B'x || '[19;2HPlease insert a 1.44MB floppy in drive 'flpdrv' and press ENTER'
	 '@pause >nul 2>>&1'
	end
	else do
		if (vdisk = 'VFDISK') then do
			call execute '@vfctrl 'flpdrv' 0'
			call execute '@vfctrl 'flpdrv' 1.44'
			rcode = result
		end
	else do
			call execute '@SVDC /ef 'flpdrv
			call execute '@SVDC /r:1.44 'flpdrv
			call execute '@SVDC /i:1.44 'flpdrv
			rcode = result
		end
	end
	if rcode <> 0 then do
		say '1B'x || '[19;2HError inserting 1.44MB floppy, press any key to try it again'
		'@pause >nul 2>>&1'
	end
end

/* update floppy images */
rc = lineout(log, 'Info: Creating installation floppies from 'iddir' and 'fpdir'... ('date() time()', version 'ver')')
rc = lineout(log)
call create_flop 'ECS0'
call report_status
call create_flop 'ECS1'
call report_status
call create_flop 'ECS2'
call report_status
call create_flop 'ECSNCSM0'
call report_status
call create_flop 'ECSNCSM1'
call report_status
call create_flop 'ECSNCSM2'
call report_status

/* update boot images */
iddir = cddir||'\BOOTIMGS'
exdir = cddir||'\ECS'
rc = lineout(log, 'Info: Creating boot images from 'iddir' and 'fpdir'... ('date() time()', version 'ver')')
rc = lineout(log)

/* check vdisk type */
vdisk = SysIni(, 'UPDCD', 'VDISK')
if (vdisk == 'ERROR:') then do
	vdisk = 'SVDISK' /* let us make SVDISK the default */
	call SysIni , 'UPDCD', 'VDISK', vdisk
end 

/* insert floppy */
rcode = 1
do while rcode <> 0
	/* ask the user to do something useful :-) */
	if expert = 0 then do
		say '1B'x || '[19;2HPlease insert a 2.88MB floppy in drive 'flpdrv' and press ENTER'
		'@pause >nul 2>>&1'
	end
	else do
		if (vdisk = 'VFDISK') then do
			call execute '@vfctrl 'flpdrv' 0'
			call execute '@vfctrl 'flpdrv' 2.88'
			rcode = result
		end
	else do
			call execute '@SVDC /ef 'flpdrv
			call execute '@SVDC /r:2.88 'flpdrv
			call execute '@SVDC /i:2.88 'flpdrv
			rcode = result
		end
	end
	if rcode <> 0 then do
		say '1B'x || '[19;2HError inserting 2.88MB floppy, press any key to try it again'
		'@pause >nul 2>>&1'
	end
end

/* unpack and update boot images */
call execute '@'exdir'\image.exe 'iddir'\disk_0_1.img 'flpdrv
'@del result.out >nul 2>>&1'
'@call updcd 'flpdrv fpdir n.errors n.warnings trunc(time('E')/60 + n.elapsed, 2) log ver
res = linein('result.out')
rc = lineout('result.out')
parse var res n.errors n.warnings
cdir = chdir()
rc = chdir(burn'\ecs')
call execute '@os2csm.exe 'flpdrv' /I'
rc = chdir(cdir)
call execute '@xcopy 'flpdrv'\* 'cddir'\updcd\bootimg\DISK_0_1.IMG\.'
call execute '@'exdir'\image.exe 'flpdrv iddir'\disk_0_1.img'
call execute '@'exdir'\image.exe 'iddir'\disk_2.img 'flpdrv
'@del result.out >nul 2>>&1'
'@call updcd 'flpdrv fpdir n.errors n.warnings trunc(time('E')/60 + n.elapsed, 2) log ver
res = linein('result.out')
rc = lineout('result.out')
parse var res n.errors n.warnings
call execute '@xcopy 'flpdrv'\* 'cddir'\updcd\bootimg\DISK_2.IMG\.'
call execute '@'exdir'\image.exe 'flpdrv iddir'\disk_2.img'

if n.elapsed > 0 then do
	rc = lineout('result.out', n.errors||' '||n.warnings, 1)
end

exit 

/* create and update install floppy */
create_flop: procedure expose log iddir fpdir cddir exdir n. ver flpdrv compress f1dir f2dir vers add_dummy add_dani addons

	parse upper arg disk
	image = iddir || '\' || disk || '.dsk'

	/* create installation floppy */
	say '1B'x || '[7;26HCreating 'disk
	call execute '@'exdir'\loaddskf 'image flpdrv' /Y /Q /S /F '

	/* preprocessing */
	if disk = 'ECS2' then call execute '@del 'flpdrv'\jfs.ifs'

	/* update floppy */
	'@del result.out >nul 2>>&1'
	'@call updcd 'flpdrv fpdir n.errors n.warnings trunc(time('E')/60 + n.elapsed, 2) log ver
	res = linein('result.out')
	rc = lineout('result.out')
	parse var res n.errors n.warnings

	/* postprocessing floppy */
	say '1B'x || '[7;26H'substr('Postprocessing 'disk, 1, 50)

	if disk = 'ECS0' | disk = 'ECSNCSM0' then do
		call execute '@del 'flpdrv'\os2krnli'
		call execute '@copy 'fpdir'\os2krnl 'flpdrv'\os2krnli'
		if disk = 'ECS0' then do
			cdir = chdir()
			rc = chdir(burn'\ecs')
			call execute '@copy 'flpdrv'\config.s 'flpdrv'\config.sys'
			call execute '@os2csm.exe 'flpdrv' /I'
			call execute '@del 'flpdrv'\config.sys'
			rc = chdir(cdir)
		end
		if compress = 1 then call execute '@lxlite 'flpdrv'\*'
	end

	if disk = 'ECS1' | disk = 'ECSNCSM1' then do
		/* read config.sys from boot floppy */
		config_file = flpdrv'\CONFIG.SYS'
		/* add drivers if they are placed in newinst */
		if add_dummy = 1 then do
			rc = SysFileTree('newinst\*.add', 'drivers.', 'FO')
			do i = 1 to drivers.0
		   		call execute '@copy 'drivers.i flpdrv'\.'
					drivers.i = translate(substr(drivers.i, lastpos('\', drivers.i)+1))
					gevonden = 0
					do while lines(flpdrv'\config.sys')
						l = translate(linein(flpdrv'\config.sys'))
						if l = 'BASEDEV='drivers.i then gevonden = 1
					end
					call lineout flpdrv'\config.sys'
					if gevonden = 0 then '@echo BASEDEV='drivers.i' >> 'flpdrv'\config.sys'
			end
		end
		if compress = 1 then call execute '@lxlite 'flpdrv'\*'
	end

	if disk = 'ECS2' | disk = 'ECSNCSM2' then do
		call execute '@lxlite 'flpdrv'\*'
	end

	/* generate updated image */
	say '1B'x || '[4;2HTarget directory      : 'substr(iddir, 1, 50)
	say '1B'x || '[5;2HSource directory      : 'substr(flpdrv'\', 1, 50)
	say '1B'x || '[7;26H'substr('Updating CD image', 1, 50)
	say '1B'x || '[19;2H'substr(' ', 1, 70)
	call execute '@savedskf 'flpdrv image

	/* clean up */
	call deldir 'tmp' 

return

/* execute command, display it and write to log */ 
execute: procedure expose log n. iddir flpdrv

	parse arg comm
	parse upper var comm comm1 comm2 comm3 comm4 rest
	say '1B'x || '[8;26H'substr(comm3, 1, 50)
	say '1B'x || '[9;26H'substr(comm2, 1, 50)
	say '1B'x || '[11;26H'substr(comm1, 2, 50)
	comm '>nul 2>>&1'
	rcode = rc
	say '1B'x || '[12;26H'rcode' '

	if rcode <> 0 then do
		rc = lineout(log, 'Error: 'comm' (rc='rcode')')
		rc = lineout(log)
		n.errors = n.errors + 1
	end
	else do
		rc = lineout(log, 'Info: 'comm' (rc='rcode')')
		rc = lineout(log)
	end

	call report_status

return rcode

/* display status */
report_status: procedure expose n. iddir flpdrv

	say '1B'x || '[4;2HTarget directory      : 'substr(flpdrv'\', 1, 50)
	say '1B'x || '[5;2HSource directory      : 'substr(iddir, 1, 50)
	say '1B'x || '[7;2HCurrent activity      : 'substr('Thinking...', 1, 50)
	say '1B'x || '[8;2HTarget object         : 'substr('Searching...', 1, 50)
	say '1B'x || '[9;2HSource object         : 'substr('Searching...', 1, 50)
	say '1B'x || '[11;2HUpdate action         : 'substr('Searching...', 1, 50)
	say '1B'x || '[12;2HUpdate return code    : 0'
	say '1B'x || '[14;2HElapsed time [m]      : 'trunc(time('E')/60 + n.elapsed, 2)
	say '1B'x || '[15;2HNumber of errors      : 'n.errors
	say '1B'x || '[16;2HNumber of warnings    : 'n.warnings
	say '1B'x || '[19;2H'

return

DelDir: procedure expose n. log iddir flpdrv

	parse arg Directory
	DirSpec = Directory || '\*'

	/* delete subdirectories */
	rc = SysFileTree(DirSpec, Subdirs, 'DO', '*****', '-*---')
	do i = 1 to Subdirs.0
   		call DelDir Subdirs.i
	end

	/* delete files */
	rc = SysFileTree(DirSpec, Files, 'FO', '*****', '-*---')
	do i = 1 to Files.0
			if pos('EA DATA. SF', Files.i) = 0 then call execute '@del 'Files.i
  end

	/* delete directory */
	cdir = chdir()
	d = chdir(Directory)
	cdir = chdir(cdir)
	if d <> '' & d <> cdir & substr(Directory, 2) <> ':' then call execute '@rmdir 'Directory

return

/* copy files from sdir to tdir except ea data. sf */
CopyDir: procedure expose log n.

	parse arg sdir tdir 

	call SysFileTree sdir'\*', ini., 'FO', , '**---'
	do i=1 to ini.0
		if pos('EA DATA. SF', translate(ini.i)) = 0 then do
			'@copy 'ini.i tdir'\. >nul 2>>&1'
			rcode = rc
			if rcode <> 0 then do
				rc = lineout(log, 'Error: @copy 'ini.i tdir'\. (rc='rcode')')
				rc = lineout(log)
				n.errors = n.errors + 1
			end
			else do
				rc = lineout(log, 'Info: @copy 'ini.i tdir'\. (rc='rcode')')
				rc = lineout(log)
			end
		end
	end
	call report_status

return

/* read the updcd cfg file and get absolute directory path */
Read_Config_File: 

	parse arg cfgfile

	/* check */
	if stream(cfgfile, 'c', 'query exists') = '' then do
		say 'Fatal error! The configuration file ('cfgfile') is missing.'
		say 'Please run INSTALL.CMD to create one.'
		'@pause'
		exit 9
	end

	/* read file */
	do while lines(cfgfile)
		l = linein(cfgfile)
		interpret l
	end
	call lineout cfgfile 

	/* need to know abolute path */
	cdir    = chdir()
	burn    = chdir(burn)
	cdir    = chdir(cdir)
	w4cd		= chdir(w4cd)
	cdir    = chdir(cdir)
	fixes   = chdir(fixes)
	cdir    = chdir(cdir)
	updates = chdir(updates)
	cdir    = chdir(cdir)
	addons  = chdir(addons)
	cdir    = chdir(cdir)
	rootdir = chdir(rootdir)
	cdir    = chdir(cdir)
	tempdir = chdir(tempdir)
	cdir    = chdir(cdir)
	source	= chdir(source)
	cdir    = chdir(cdir)
	cdrdir	= chdir(cdrdir)
	cdir    = chdir(cdir)

	/* need to know abolute path for files */
	if filespec('drive', log) = '' then 
		log	= cdir||'\'||filespec('name', log)
	if filespec('drive', tempraw) = '' then 
		tempraw	= cdir||'\'||filespec('name', tempraw)
	if filespec('drive', burnlog) = '' then 
		burnlog	= cdir||'\'||filespec('name', burnlog)

return

/* chdir: drive and path aware directory() replacement       */
/*        returns the current dir without trailing backslash */
chdir: procedure
	parse upper arg dr                /* get target dir        */
	if length(dr) > 1 then dr = strip(dr, 'T', '\')
	cdir = directory()                /* get current dir       */
	if substr(dr, 2, 1) = ':' then do /* absolute path         */
		drive = substr(dr, 1, 2)
		rc = directory(drive)           /* change to drive       */
		if substr(rc, 1, 2) <> drive then 
			return strip(directory(cdir), 'T', '\')
		rc = directory('\')             /* change to root        */
		rc = directory(substr(dr, 3))   /* change to path        */
		if strip(rc, 'T', '\') <> dr then 
			return strip(directory(cdir), 'T', '\')
	end
	else do
		return strip(directory(dr), 'T', '\')  /* relative path  */
	end
return strip(directory(), 'T', '\') /* return current dir    */

